package s3

import (
	"context"
	"io"

	"git.kapelle.org/niklas/s3share/internal/types"
)

type ObjectReader interface {
	io.Reader
	io.Seeker
	io.ReaderAt
	io.Closer
}

type S3 interface {
	GetObject(ctx context.Context, key string) (ObjectReader, error)
	KeyExists(ctx context.Context, key string) (bool, error)
	GetObjectMetadata(ctx context.Context, key string) (*types.Metadata, error)
}
